Package net.shibboleth.idp.cas.config

# Class ValidateConfiguration

java.lang.Object
net.shibboleth.shared.component.AbstractInitializableComponent
net.shibboleth.shared.component.AbstractIdentifiedInitializableComponent
net.shibboleth.shared.component.AbstractIdentifiableInitializableComponent
net.shibboleth.profile.config.AbstractProfileConfiguration
net.shibboleth.profile.config.AbstractConditionalProfileConfiguration
net.shibboleth.idp.profile.config.AbstractInterceptorAwareProfileConfiguration
net.shibboleth.idp.cas.config.AbstractProtocolConfiguration
net.shibboleth.idp.cas.config.ValidateConfiguration

All Implemented Interfaces:
  `InterceptorAwareProfileConfiguration`, `AttributeResolvingProfileConfiguration`, `ConditionalProfileConfiguration`, `ProfileConfiguration`, `Component`, `DestructableComponent`, `IdentifiableComponent`, `IdentifiedComponent`, `InitializableComponent`

public class ValidateConfiguration extends AbstractProtocolConfiguration
CAS protocol configuration. Applies to the following ticket validation URIs:

- `/proxyValidate`
- `/serviceValidate`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`DEFAULT_TICKET_LENGTH`
Default ticket length (random part).
`static final String`
`DEFAULT_TICKET_PREFIX`
Default ticket prefix.
`static final Duration`
`DEFAULT_TICKET_VALIDITY_PERIOD`
Default ticket validity.
`private final IdentifierGenerationStrategy`
`defaultPGTIOUGenerator`
Default PGTIOU ticket ID generator.
`private Function<ProfileRequestContext,IdentifierGenerationStrategy>`
`pgtIOUGeneratorLookupStrategy`
Lookup strategy for PGTIOU ticket ID generator.
`static final String`
`PROFILE_COUNTER`
Ticket validation profile counter name.
`static final String`
`PROFILE_ID`
Ticket validation profile ID.
`private Function<ProfileRequestContext,Comparator<String>>`
`serviceComparatorLookupStrategy`
Lookup strategy for enforcing ticket requester matches ticket validator.
`private Function<ProfileRequestContext,String>`
`userAttributeLookupStrategy`
Lookup strategy for Name of IdP attribute to use for user returned in CAS ticket validation response.

### Fields inherited from class net.shibboleth.idp.cas.config.AbstractProtocolConfiguration

`PROTOCOL_COUNTER, PROTOCOL_URI`

### Fields inherited from interface net.shibboleth.profile.config.ProfileConfiguration

`DEFAULT_DISALLOWED_FEATURES`

## Constructor Summary

Constructors
Constructor
Description
`ValidateConfiguration()`
Creates a new instance.

## Method Summary

Modifier and Type
Method
Description
`protected int`
`getDefaultTicketLength()`
Get default ticket length.
`protected String`
`getDefaultTicketPrefix()`
Get default ticket prefix.
`IdentifierGenerationStrategy`
`getPGTIOUGenerator(ProfileRequestContext profileRequestContext)`
Get the PGTIOU ticket ID generator.
`Comparator<String>`
`getServiceComparator(ProfileRequestContext profileRequestContext)`
Get component responsible for enforcing ticket requester matches ticket validator.
`String`
`getUserAttribute(ProfileRequestContext profileRequestContext)`
Get name of IdP attribute to use for username returned in CAS ticket validation response.
`void`
`setPGTIOUGenerator(IdentifierGenerationStrategy generator)`
Set the PGTIOU ticket ID generator.
`void`
`setPGTIOUGeneratorLookupStrategy(Function<ProfileRequestContext,IdentifierGenerationStrategy> strategy)`
Set the lookup strategy to use for the PGTIOU ticket ID generator.
`void`
`setServiceComparator(Comparator<String> comparator)`
Set component responsible for enforcing ticket requester matches ticket validator.
`void`
`setServiceComparatorLookupStrategy(Function<ProfileRequestContext,Comparator<String>> strategy)`
Set the lookup strategy to use for the component responsible for enforcing that the ticket requester matches the ticket validator.
`void`
`setUserAttribute(String attribute)`
Set the name of IdP attribute to use for username returned in CAS ticket validation response.
`void`
`setUserAttributeLookupStrategy(Function<ProfileRequestContext,String> strategy)`
Set the lookup strategy to use for the name of the IdP attribute to use for username returned in CAS ticket validation response.

### Methods inherited from class net.shibboleth.idp.cas.config.AbstractProtocolConfiguration

`getAttributeRecipientGroupID, getRequestedIdPAttributeNames, getSecurityConfiguration, getTicketValidityPeriod, isResolveAttributes, setAttributeRecipientGroupID, setAttributeRecipientGroupIDLookupStrategy, setRequestedIdPAttributeNames, setRequestedIdPAttributeNamesLookupStrategy, setResolveAttributes, setResolveAttributesPredicate, setTicketValidityPeriod, setTicketValidityPeriodLookupStrategy`

### Methods inherited from class net.shibboleth.idp.profile.config.AbstractInterceptorAwareProfileConfiguration

`getInboundInterceptorFlows, getOutboundInterceptorFlows, setInboundInterceptorFlows, setInboundInterceptorFlowsLookupStrategy, setOutboundInterceptorFlows, setOutboundInterceptorFlowsLookupStrategy`

### Methods inherited from class net.shibboleth.profile.config.AbstractConditionalProfileConfiguration

`getActivationCondition, setActivationCondition`

### Methods inherited from class net.shibboleth.profile.config.AbstractProfileConfiguration

`equals, getDisallowedFeatures, hashCode, isFeatureDisallowed, setDisallowedFeatures, setDisallowedFeaturesLookupStrategy, setSecurityConfiguration, setSecurityConfigurationLookupStrategy`

### Methods inherited from class net.shibboleth.shared.component.AbstractIdentifiableInitializableComponent

`setId`

### Methods inherited from class net.shibboleth.shared.component.AbstractIdentifiedInitializableComponent

`doInitialize, ensureId, getId, ifDestroyedThrowDestroyedComponentException, ifInitializedThrowUnmodifiabledComponentException, ifNotInitializedThrowUninitializedComponentException`

### Methods inherited from class net.shibboleth.shared.component.AbstractInitializableComponent

`checkComponentActive, checkSetterPreconditions, destroy, doDestroy, initialize, isDestroyed, isInitialized`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface net.shibboleth.shared.component.IdentifiedComponent

`getId`

### Methods inherited from interface net.shibboleth.shared.component.InitializableComponent

`initialize, isInitialized`

### Methods inherited from interface net.shibboleth.profile.config.ProfileConfiguration

`getDisallowedFeatures, isFeatureDisallowed`

## Field Details

### PROFILE_ID

@Nonnull @NotEmpty public static final String PROFILE_ID
Ticket validation profile ID.

See Also:
  - Constant Field Values

### PROFILE_COUNTER

@Nonnull @NotEmpty public static final String PROFILE_COUNTER
Ticket validation profile counter name.

See Also:
  - Constant Field Values

### DEFAULT_TICKET_VALIDITY_PERIOD

@Nonnull public static final Duration DEFAULT_TICKET_VALIDITY_PERIOD
Default ticket validity.

### DEFAULT_TICKET_PREFIX

@Nonnull @NotEmpty public static final String DEFAULT_TICKET_PREFIX
Default ticket prefix.

See Also:
  - Constant Field Values

### DEFAULT_TICKET_LENGTH

public static final int DEFAULT_TICKET_LENGTH
Default ticket length (random part).

See Also:
  - Constant Field Values

### pgtIOUGeneratorLookupStrategy

@Nonnull private Function<ProfileRequestContext,IdentifierGenerationStrategy> pgtIOUGeneratorLookupStrategy
Lookup strategy for PGTIOU ticket ID generator.

### defaultPGTIOUGenerator

@Nonnull private final IdentifierGenerationStrategy defaultPGTIOUGenerator
Default PGTIOU ticket ID generator.

### serviceComparatorLookupStrategy

@Nonnull private Function<ProfileRequestContext,Comparator<String>> serviceComparatorLookupStrategy
Lookup strategy for enforcing ticket requester matches ticket validator.

### userAttributeLookupStrategy

@Nonnull private Function<ProfileRequestContext,String> userAttributeLookupStrategy
Lookup strategy for Name of IdP attribute to use for user returned in CAS ticket validation response.

## Constructor Details

### ValidateConfiguration

public ValidateConfiguration()
Creates a new instance.

## Method Details

### getPGTIOUGenerator

@ConfigurationSetting(name="pGTIOUGenerator") @Nonnull public IdentifierGenerationStrategy getPGTIOUGenerator(@Nullable ProfileRequestContext profileRequestContext)
Get the PGTIOU ticket ID generator.

Parameters:
  `profileRequestContext` - current profile request context
Returns:
  PGTIOU ticket ID generator

### setPGTIOUGenerator

public void setPGTIOUGenerator(@Nonnull IdentifierGenerationStrategy generator)
Set the PGTIOU ticket ID generator.

Parameters:
  `generator` - ID generator

### setPGTIOUGeneratorLookupStrategy

public void setPGTIOUGeneratorLookupStrategy(@Nonnull Function<ProfileRequestContext,IdentifierGenerationStrategy> strategy)
Set the lookup strategy to use for the PGTIOU ticket ID generator.

Parameters:
  `strategy` - lookup strategy
Since:
  3.3.0

### getServiceComparator

@ConfigurationSetting(name="serviceComparator") @Nonnull public Comparator<String> getServiceComparator(@Nullable ProfileRequestContext profileRequestContext)
Get component responsible for enforcing ticket requester matches ticket validator.

Parameters:
  `profileRequestContext` - current profile request context
Returns:
  ticket requester/validator comparator

### setServiceComparator

public void setServiceComparator(@Nonnull Comparator<String> comparator)
Set component responsible for enforcing ticket requester matches ticket validator.

Parameters:
  `comparator` - ticket requester/validator comparator

### setServiceComparatorLookupStrategy

public void setServiceComparatorLookupStrategy(@Nonnull Function<ProfileRequestContext,Comparator<String>> strategy)
Set the lookup strategy to use for the component responsible for enforcing that the ticket requester matches the ticket validator.

Parameters:
  `strategy` - lookup strategy
Since:
  3.3.0

### getUserAttribute

@ConfigurationSetting(name="userAttribute") @Nullable public String getUserAttribute(@Nullable ProfileRequestContext profileRequestContext)
Get name of IdP attribute to use for username returned in CAS ticket validation response.

Parameters:
  `profileRequestContext` - current profile request context
Returns:
  attribute name

### setUserAttribute

public void setUserAttribute(@Nullable String attribute)
Set the name of IdP attribute to use for username returned in CAS ticket validation response.

Parameters:
  `attribute` - attribute name to use

### setUserAttributeLookupStrategy

public void setUserAttributeLookupStrategy(@Nonnull Function<ProfileRequestContext,String> strategy)
Set the lookup strategy to use for the name of the IdP attribute to use for username returned in CAS ticket validation response.

Parameters:
  `strategy` - lookup strategy
Since:
  3.3.0

### getDefaultTicketPrefix

@Nonnull @NotEmpty protected String getDefaultTicketPrefix()
Get default ticket prefix.

Specified by:
  `getDefaultTicketPrefix` in class `AbstractProtocolConfiguration`
Returns:
  prefix

### getDefaultTicketLength

protected int getDefaultTicketLength()
Get default ticket length.

Specified by:
  `getDefaultTicketLength` in class `AbstractProtocolConfiguration`
Returns:
  length